package com.sw.controller;

import com.sw.service.SnatchMaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @Description 抢口罩入口
 * @Author DingLan
 * @Date 2022/2/18 13:13
 **/
@RestController
@RequestMapping("/mask")
public class SnatchMaskController {

    @Resource
    private RedisTemplate redisTemplate;

    @Autowired
    private SnatchMaskService snatchMaskService;

    @GetMapping()
    private String snatch(Integer uid){
        if(redisTemplate.opsForSet().isMember("userUids", uid)){
            if(redisTemplate.opsForSet().isMember("successUserUids", uid)){
                return "你已经抢到了";
            }else{
                return snatchMaskService.doSnatch(uid);
            }
        }else{
            return "非法输入";
        }
    }
}
