package com.sw.controller;

import com.sw.service.SysUserService;
import com.sw.service.TMaskService;
import com.sw.service.TOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.*;

/**
 * 秒杀服务
 *
 * @author yegang
 * @create 2022-02-18 13:16
 **/
@RestController

public class SpikeController {
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private TOrderService tOrderService;
    @Autowired
    private TMaskService tMaskService;
    @Autowired
    private RedisTemplate redisTemplate;

    @GetMapping("spike/{mid}/{uid}")
    public  String spike(@PathVariable("mid") Integer mid, @PathVariable("uid") Integer uid) {
        //判断用户是否存在
        Boolean HasUserUid = redisTemplate.opsForSet().isMember("userUid", uid);
        if (!HasUserUid) {
            return "用户不存在";
        }
        //2.是否已经抢购成功
        Boolean successUser = redisTemplate.opsForSet().isMember("success-" + mid, uid);
        if (successUser) {
            return "一个用户只能抢购一次";
        }
        String res = tMaskService.spike(mid, uid);
        return res;
    }
}
